from utils import read_config, save_csv, read_csv_to_df, read_classes, read_xml_to_df, COLUMNS
from datetime import datetime
import pandas as pd

now = datetime.now()
date_time = now.strftime("%H_%M_%d_%m_%Y")

bigbang_csv_name = 'worten.csv'

def execute():
    new_products = []
    
    feed_csv = read_csv_to_df('download/feeds_combined_nonvida.csv')
    feed_csv = feed_csv.drop_duplicates(subset=['sku_feed'], keep='first')
    bigbang_csv = read_csv_to_df(f'download/{bigbang_csv_name}')
    bigbang_csv = bigbang_csv.rename(columns={'product-id': 'product_id', 'product-id-type': 'product_id_type', 'discount-start-date': 'discount_start_date', 'discount-end-date': 'discount_end_date', 'discount-price': 'discount_price', 'leadtime-to-ship': 'leadtime_to_ship', 'logistic-class': 'logistic_class'})
    
    inner_join = pd.merge(bigbang_csv, feed_csv, how='left', left_on=['sku'], right_on=['sku_feed'])
    feed_csv = read_csv_to_df('download/feeds_combined_nonvida_es.csv')
    feed_csv = feed_csv.drop_duplicates(subset=['sku_feed_es'], keep='first')
    inner_join = pd.merge(inner_join, feed_csv, how='left', left_on=['sku'], right_on=['sku_feed_es'])
    len = inner_join.shape[0]
    for prod in inner_join.itertuples():
        print(f"{getattr(prod, 'Index')}/{len}", end='\r')
        new_product = dict.fromkeys(COLUMNS, '')
        new_product['sku'] = str(getattr(prod, 'sku')).replace('.0', '')
        new_product['leadtime-to-ship'] = str(getattr(prod, 'leadtime_to_ship_feed')).replace('.0', '')
        new_product['product-id'] = getattr(prod, 'product_id')
        new_product['product-id-type'] = getattr(prod, 'product_id_type')
        new_product['discount-start-date'] = getattr(prod, 'discount_start_date')
        new_product['discount-end-date'] = getattr(prod, 'discount_end_date')
        new_product['logistic-class'] = getattr(prod, 'logistic_class')
        if pd.notna(getattr(prod, 'sku_feed')):
            new_product['quantity'] = str(getattr(prod, 'stock_feed')).replace('.0', '')
            new_product['price'] = getattr(prod, 'price_feed')
            new_product['price[channel=WRT_PT_ONLINE]'] = getattr(prod, 'price_feed')
            new_product['price[channel=WRT_ES_ONLINE]'] = getattr(prod, 'price_feed_es')
        else:
            new_product['leadtime-to-ship'] = str(getattr(prod, 'leadtime_to_ship')).replace('nan', '')
            new_product['logistic-class'] = getattr(prod, 'logistic_class')
            new_product['quantity'] = '0'
            new_product['price'] = float(getattr(prod, 'price'))
        try:
            if int(new_product['quantity']) < 4:
                new_product['quantity'] = '0'
            if float(new_product['price']) < 3.99:
                new_product['price'] = '3.99'
        except:
            new_product['quantity'] = '0'
            new_product['price'] = '1500'
        new_products.append(new_product)
            
    save_csv(f'results/{bigbang_csv_name}', new_products)
        
if __name__ == "__main__":
    execute()
